(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('angular-magnolia', ['exports', '@angular/core', '@angular/common/http', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory(global['angular-magnolia'] = {}, global.ng.core, global.ng.common.http, global.rxjs.operators, global.ng.common));
}(this, function (exports, core, http, operators, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function _window() {
        return window;
    }
    var WindowRef = /** @class */ (function () {
        function WindowRef() {
        }
        Object.defineProperty(WindowRef.prototype, "nativeWindow", {
            //Return the native Javascript window object
            get: 
            //Return the native Javascript window object
            /**
             * @return {?}
             */
            function () {
                return _window();
            },
            enumerable: true,
            configurable: true
        });
        WindowRef.decorators = [
            { type: core.Injectable }
        ];
        return WindowRef;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MagnoliaContextService = /** @class */ (function () {
        /**
         * Constructor
         */
        function MagnoliaContextService(winRef, http, environment) {
            this.winRef = winRef;
            this.http = http;
            this.environment = environment;
            this.nativeWindow = winRef.nativeWindow;
            this.singlePageConfig = this.nativeWindow.singlePageConfig;
            this.fragmentURL = "/";
            if (this.singlePageConfig == null) {
                this.singlePageConfig = {};
            }
            else {
                this.contentNode = Promise.resolve(this.singlePageConfig.content);
            }
        }
        /**
         * Set the fragment URL.
         *
         * @param fragement URL
         */
        /**
         * Set the fragment URL.
         *
         * @param {?} fragment
         * @return {?}
         */
        MagnoliaContextService.prototype.setFragmentURL = /**
         * Set the fragment URL.
         *
         * @param {?} fragment
         * @return {?}
         */
        function (fragment) {
            //If production mode, then gather content through a REST call
            if (!this.environment.mgnEditMode) {
                this.fragmentURL = fragment;
                this.contentNode = this.retrievePageContent();
            }
        };
        /**
         * Return whether the page is in edition mode
         *
         * @return Whether the page is in edition mode
         */
        /**
         * Return whether the page is in edition mode
         *
         * @return {?} Whether the page is in edition mode
         */
        MagnoliaContextService.prototype.isEditionMode = /**
         * Return whether the page is in edition mode
         *
         * @return {?} Whether the page is in edition mode
         */
        function () {
            return this.environment.mgnEditMode;
        };
        /**
         * Returns the current Magnolia JCR node path.
         */
        /**
         * Returns the current Magnolia JCR node path.
         * @return {?}
         */
        MagnoliaContextService.prototype.getCurrentNode = /**
         * Returns the current Magnolia JCR node path.
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var content;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.contentNode];
                        case 1:
                            content = _a.sent();
                            return [2 /*return*/, content["@path"]];
                    }
                });
            });
        };
        /**
         * Return the the defined area in the Magnolia context
         *
         * @param areaName The name of the area
         */
        /**
         * Return the the defined area in the Magnolia context
         *
         * @param {?} areaName The name of the area
         * @return {?}
         */
        MagnoliaContextService.prototype.getAreaContent = /**
         * Return the the defined area in the Magnolia context
         *
         * @param {?} areaName The name of the area
         * @return {?}
         */
        function (areaName) {
            return __awaiter(this, void 0, void 0, function () {
                var content;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.contentNode];
                        case 1:
                            content = _a.sent();
                            return [2 /*return*/, content[areaName]];
                    }
                });
            });
        };
        /**
         * Return the area's defined components
         *
         * @param areaName The name of the area
         */
        /**
         * Return the area's defined components
         *
         * @param {?} areaName The name of the area
         * @return {?}
         */
        MagnoliaContextService.prototype.getAreaComponents = /**
         * Return the area's defined components
         *
         * @param {?} areaName The name of the area
         * @return {?}
         */
        function (areaName) {
            return __awaiter(this, void 0, void 0, function () {
                var results, content, areaContent, components;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            results = new Array();
                            return [4 /*yield*/, this.contentNode];
                        case 1:
                            content = _a.sent();
                            ;
                            //Gets the area content
                            areaContent = content[areaName];
                            if (areaContent != null) {
                                components = areaContent["@nodes"];
                                components.map((/**
                                 * @param {?} nodeName
                                 * @return {?}
                                 */
                                function (nodeName) {
                                    /** @type {?} */
                                    var value = areaContent[nodeName];
                                    if (typeof (value) === "object" && value["@nodeType"] === "mgnl:component") {
                                        results.push(value);
                                    }
                                }));
                            }
                            return [2 /*return*/, results];
                    }
                });
            });
        };
        /**
         * Return the component mapping
         *
         * @param nodePath The component mapping
         */
        /**
         * Return the component mapping
         *
         * @param {?} templateId
         * @return {?}
         */
        MagnoliaContextService.prototype.getComponentMapping = /**
         * Return the component mapping
         *
         * @param {?} templateId
         * @return {?}
         */
        function (templateId) {
            if (this.singlePageConfig.componentMappings !== null) {
                return this.singlePageConfig.componentMappings[templateId];
            }
            else {
                return null;
            }
        };
        /**
         * Return the HTML comment
         *
         * @param nodePath The node path
         */
        /**
         * Return the HTML comment
         *
         * @param {?} nodePath The node path
         * @return {?}
         */
        MagnoliaContextService.prototype.getHtmlComment = /**
         * Return the HTML comment
         *
         * @param {?} nodePath The node path
         * @return {?}
         */
        function (nodePath) {
            if (this.singlePageConfig.htmlComments !== null) {
                return this.singlePageConfig.htmlComments[nodePath];
            }
            else {
                return null;
            }
        };
        /**
         * Return the page content JSON
         */
        /**
         * Return the page content JSON
         * @private
         * @return {?}
         */
        MagnoliaContextService.prototype.retrievePageContent = /**
         * Return the page content JSON
         * @private
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = this.singlePageConfig;
                            return [4 /*yield*/, this.retrieveComponentMappings()];
                        case 1:
                            _a.componentMappings = _b.sent();
                            return [2 /*return*/, this.http.get(this.environment.restUrl + this.fragmentURL).pipe(operators.map((/**
                                 * @param {?} response
                                 * @return {?}
                                 */
                                function (response) {
                                    //console.log("retrievePageContent with " + this.fragmentURL + " value " + JSON.stringify(response,
                                    // null, 2));
                                    return response;
                                }))).toPromise()];
                    }
                });
            });
        };
        /**
         * Return the fragment content JSON
         */
        /**
         * Return the fragment content JSON
         * @private
         * @return {?}
         */
        MagnoliaContextService.prototype.retrieveComponentMappings = /**
         * Return the fragment content JSON
         * @private
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.http.get(this.environment.configRestUrl + this.fragmentURL).pipe(operators.map((/**
                         * @param {?} response
                         * @return {?}
                         */
                        function (response) {
                            //console.log("retrieveComponentMappings with " + this.fragmentURL + " value " +
                            // JSON.stringify(response, null, 2));
                            return response;
                        }))).toPromise()];
                });
            });
        };
        MagnoliaContextService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        MagnoliaContextService.ctorParameters = function () { return [
            { type: WindowRef },
            { type: http.HttpClient },
            { type: undefined, decorators: [{ type: core.Inject, args: ['env',] }] }
        ]; };
        /** @nocollapse */ MagnoliaContextService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function MagnoliaContextService_Factory() { return new MagnoliaContextService(core.ɵɵinject(WindowRef), core.ɵɵinject(http.HttpClient), core.ɵɵinject("env")); }, token: MagnoliaContextService, providedIn: "root" });
        return MagnoliaContextService;
    }());
    if (false) {
        /**
         * Native window object.
         * @type {?}
         */
        MagnoliaContextService.prototype.nativeWindow;
        /**
         * Single page config.
         * @type {?}
         */
        MagnoliaContextService.prototype.singlePageConfig;
        /**
         * Fragment URL.
         * @type {?}
         */
        MagnoliaContextService.prototype.fragmentURL;
        /**
         * Content node.
         * @type {?}
         * @private
         */
        MagnoliaContextService.prototype.contentNode;
        /**
         * @type {?}
         * @private
         */
        MagnoliaContextService.prototype.winRef;
        /**
         * @type {?}
         * @private
         */
        MagnoliaContextService.prototype.http;
        /**
         * @type {?}
         * @private
         */
        MagnoliaContextService.prototype.environment;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function MagnoliaComponent() { }
    if (false) {
        /**
         * Component config.
         * @type {?}
         */
        MagnoliaComponent.prototype.component;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ComponentDirective = /** @class */ (function () {
        /**
         * Constructor.
         */
        function ComponentDirective(el, mgnCtxService, viewContainerRef) {
            this.el = el;
            this.mgnCtxService = mgnCtxService;
            this.viewContainerRef = viewContainerRef;
            this.nativeElement = el.nativeElement;
        }
        /**
         * On init
         */
        /**
         * On init
         * @return {?}
         */
        ComponentDirective.prototype.ngOnInit = /**
         * On init
         * @return {?}
         */
        function () {
            if (this.mgnCtxService.isEditionMode()) {
                //Get the HTML comment
                /** @type {?} */
                var htmlComment = this.mgnCtxService.getHtmlComment(this.component['@path']);
                //Get parent
                /** @type {?} */
                var parentDiv = this.nativeElement.parentNode;
                //Create comment before
                /** @type {?} */
                var commentBefore = document.createComment(htmlComment.start);
                parentDiv.appendChild(commentBefore);
                //Create comment after
                /** @type {?} */
                var commentAfter = document.createComment(htmlComment.end);
                parentDiv.appendChild(commentAfter);
                //Insert comment before
                parentDiv.insertBefore(commentBefore, this.nativeElement);
                //Insert comment after
                parentDiv.insertBefore(commentAfter, this.nativeElement.nextSibling);
            }
        };
        ComponentDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[cmsComponent]'
                    },] }
        ];
        /** @nocollapse */
        ComponentDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: MagnoliaContextService },
            { type: core.ViewContainerRef }
        ]; };
        ComponentDirective.propDecorators = {
            component: [{ type: core.Input }]
        };
        return ComponentDirective;
    }());
    if (false) {
        /**
         * Native element.
         * @type {?}
         */
        ComponentDirective.prototype.nativeElement;
        /**
         * Component config.
         * @type {?}
         */
        ComponentDirective.prototype.component;
        /**
         * @type {?}
         * @private
         */
        ComponentDirective.prototype.el;
        /**
         * @type {?}
         * @private
         */
        ComponentDirective.prototype.mgnCtxService;
        /** @type {?} */
        ComponentDirective.prototype.viewContainerRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AbstractArea = /** @class */ (function () {
        /**
         * Constructor
         */
        function AbstractArea(elementRef, mgnCtxService, resolver) {
            this.elementRef = elementRef;
            this.mgnCtxService = mgnCtxService;
            this.resolver = resolver;
        }
        /**
         * On init
         */
        /**
         * On init
         * @return {?}
         */
        AbstractArea.prototype.ngOnInit = /**
         * On init
         * @return {?}
         */
        function () {
            var _this = this;
            this.mgnCtxService.getAreaComponents(this.cmsArea).then((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                _this.components = data;
            }));
        };
        /**
         * Loads component after init
         */
        /**
         * Loads component after init
         * @return {?}
         */
        AbstractArea.prototype.ngAfterViewInit = /**
         * Loads component after init
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var current = this;
            //Attempt to load directly after init
            this.loadComponents(current);
            //Otherwise, observe the changes on the list of templates
            this.templates.changes.subscribe((/**
             * @return {?}
             */
            function () { return _this.loadComponents(current); }));
        };
        /**
         * Loads the components dynamically.
         *
         * @param current The current area
         */
        /**
         * Loads the components dynamically.
         *
         * @param {?} current The current area
         * @return {?}
         */
        AbstractArea.prototype.loadComponents = /**
         * Loads the components dynamically.
         *
         * @param {?} current The current area
         * @return {?}
         */
        function (current) {
            current.templates.forEach((/**
             * @param {?} item
             * @param {?} index
             * @param {?} array
             * @return {?}
             */
            function (item, index, array) {
                //Gets the component
                /** @type {?} */
                var component = item.component;
                // Gets the component class
                /** @type {?} */
                var componentClass = current.mgnCtxService.getComponentMapping(component["mgnl:template"]);
                if (typeof componentClass !== "undefined") {
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        current.loadComponent(componentClass, item, component);
                    }));
                }
            }));
        };
        /**
         * Loads the components thanks to its cmsTemplateId
         */
        /**
         * Loads the components thanks to its cmsTemplateId
         * @param {?} componentClassName
         * @param {?} item
         * @param {?} component
         * @return {?}
         */
        AbstractArea.prototype.loadComponent = /**
         * Loads the components thanks to its cmsTemplateId
         * @param {?} componentClassName
         * @param {?} item
         * @param {?} component
         * @return {?}
         */
        function (componentClassName, item, component) {
            /** @type {?} */
            var factories = Array.from(this.resolver['_factories'].keys());
            /** @type {?} */
            var componentClass = factories.find((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                return (x.key === componentClassName || x.name === componentClassName);
            }));
            //Gets the component factory
            /** @type {?} */
            var componentFactory = this.resolver.resolveComponentFactory((/** @type {?} */ (componentClass)));
            //Get the view container
            item.viewContainerRef.clear();
            /** @type {?} */
            var componentRef = item.viewContainerRef.createComponent(componentFactory);
            ((/** @type {?} */ (componentRef.instance))).component = component;
        };
        AbstractArea.decorators = [
            { type: core.Component, args: [{
                        template: ""
                    }] }
        ];
        /** @nocollapse */
        AbstractArea.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: MagnoliaContextService },
            { type: core.ComponentFactoryResolver }
        ]; };
        AbstractArea.propDecorators = {
            cmsArea: [{ type: core.Input }],
            templates: [{ type: core.ViewChildren, args: [ComponentDirective,] }]
        };
        return AbstractArea;
    }());
    if (false) {
        /**
         * Area name.
         * @type {?}
         */
        AbstractArea.prototype.cmsArea;
        /**
         * List of area's components.
         * @type {?}
         */
        AbstractArea.prototype.components;
        /**
         * List of the component view containers.
         * @type {?}
         */
        AbstractArea.prototype.templates;
        /**
         * @type {?}
         * @private
         */
        AbstractArea.prototype.elementRef;
        /**
         * @type {?}
         * @private
         */
        AbstractArea.prototype.mgnCtxService;
        /**
         * @type {?}
         * @private
         */
        AbstractArea.prototype.resolver;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ListArea = /** @class */ (function (_super) {
        __extends(ListArea, _super);
        function ListArea() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ListArea.decorators = [
            { type: core.Component, args: [{
                        selector: "[list-area]",
                        template: "<ng-template ngFor let-component [ngForOf]=\"components\">\n    <ng-template [component]=\"component\" cmsComponent></ng-template>\n</ng-template>"
                    }] }
        ];
        return ListArea;
    }(AbstractArea));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AreaDirective = /** @class */ (function () {
        /**
         * Constructor.
         */
        function AreaDirective(el, mgnCtxService) {
            this.el = el;
            this.mgnCtxService = mgnCtxService;
        }
        /**
         * On init
         */
        /**
         * On init
         * @return {?}
         */
        AreaDirective.prototype.ngOnInit = /**
         * On init
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.mgnCtxService.isEditionMode()) {
                //Get the area node
                this.mgnCtxService.getAreaContent(this.cmsArea).then((/**
                 * @param {?} areaNode
                 * @return {?}
                 */
                function (areaNode) {
                    //Get the HTML comment
                    /** @type {?} */
                    var htmlComment = _this.mgnCtxService.getHtmlComment(areaNode["@path"]);
                    //Get parent
                    /** @type {?} */
                    var parentDiv = _this.el.nativeElement.parentNode;
                    //Create comment before
                    /** @type {?} */
                    var commentBefore = document.createComment(htmlComment.start);
                    parentDiv.appendChild(commentBefore);
                    //Create comment after
                    /** @type {?} */
                    var commentAfter = document.createComment(htmlComment.end);
                    parentDiv.appendChild(commentAfter);
                    //Insert comment before
                    parentDiv.insertBefore(commentBefore, _this.el.nativeElement);
                    //Insert comment after
                    parentDiv.insertBefore(commentAfter, _this.el.nativeElement.nextSibling);
                }));
            }
        };
        AreaDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[cmsArea]'
                    },] }
        ];
        /** @nocollapse */
        AreaDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: MagnoliaContextService }
        ]; };
        AreaDirective.propDecorators = {
            cmsArea: [{ type: core.Input }]
        };
        return AreaDirective;
    }());
    if (false) {
        /**
         * Area name.
         * @type {?}
         */
        AreaDirective.prototype.cmsArea;
        /**
         * @type {?}
         * @private
         */
        AreaDirective.prototype.el;
        /**
         * @type {?}
         * @private
         */
        AreaDirective.prototype.mgnCtxService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularMagnoliaModule = /** @class */ (function () {
        function AngularMagnoliaModule() {
        }
        /**
         * @param {?} environment
         * @return {?}
         */
        AngularMagnoliaModule.forRoot = /**
         * @param {?} environment
         * @return {?}
         */
        function (environment) {
            return {
                ngModule: AngularMagnoliaModule,
                providers: [
                    WindowRef,
                    {
                        provide: 'env',
                        useValue: environment
                    }
                ]
            };
        };
        AngularMagnoliaModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, http.HttpClientModule],
                        declarations: [
                            AreaDirective,
                            ComponentDirective,
                            AbstractArea,
                            ListArea
                        ],
                        providers: [
                            WindowRef
                        ],
                        exports: [
                            AreaDirective,
                            ListArea,
                            ComponentDirective
                        ]
                    },] }
        ];
        return AngularMagnoliaModule;
    }());

    exports.AbstractArea = AbstractArea;
    exports.AngularMagnoliaModule = AngularMagnoliaModule;
    exports.AreaDirective = AreaDirective;
    exports.ComponentDirective = ComponentDirective;
    exports.ListArea = ListArea;
    exports.MagnoliaContextService = MagnoliaContextService;
    exports.ɵa = WindowRef;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular-magnolia.umd.js.map
