import { ElementRef, OnInit, ViewContainerRef } from '@angular/core';
import { MagnoliaContextService } from '../services/magnolia-context.service';
export declare class ComponentDirective implements OnInit {
    private el;
    private mgnCtxService;
    viewContainerRef: ViewContainerRef;
    /** Native element. */
    nativeElement: any;
    /** Component config.*/
    component: any;
    /**
     * Constructor.
     */
    constructor(el: ElementRef, mgnCtxService: MagnoliaContextService, viewContainerRef: ViewContainerRef);
    /**
     * On init
     */
    ngOnInit(): void;
}
